import greenfoot.*;
import java.awt.Color;

/**
 * The world of which you're able to build components onto
 * 
 * @author Jamie Vaughan
 * @version 1.0
 */
public class Matrix extends World {

    /** The colour used to colourize the background **/
    public static Color WORLD_COLOUR = Color.BLACK;
    
    /** This is the colour used for the code objects **/
    public static Color CODE_COLOUR = Color.GREEN;
    
    /** The time between each line of code is generated **/
    public static long TIME = 200;
    
    /** Store when the last action was held **/
    public long LAST_ACTION = System.currentTimeMillis();

    /**
     * Constructor for objects of class Martrix.
     */
    public Matrix() {
        super(400, 400, 1);
        colourize();
        append();
    }
    
    /**
     * Append the action every so-often
     */
    public void act() {
        if(System.currentTimeMillis() - LAST_ACTION > TIME) {
            append();
            LAST_ACTION = System.currentTimeMillis();
        }
    }
    
    /**
     * Append the code onto the world
     */
    public void append() {
        this.addObject(new Code(CODE_COLOUR, true, Greenfoot.getRandomNumber(15) + 1), 15 * (int)(Math.random() * getHeight() / 15), 5);
    }
    
    /**
     * Append some colour to the world
     */
    public void colourize() {
        getBackground().setColor(WORLD_COLOUR);
        getBackground().fill();
    }
}
